<?php
/**
 * DeliciousScraper.class.php
 * 
 * a simple HTML scraper class to extract all tags from a http://del.icio.us user page
 *
 * @author Karsten Schmidt <info@toxi.co.uk>
 * @version 0.1
 * 
 * @example $scraper = new DeliciousScraper();
 * @example $tags = $scraper->getAllTagsForUser('toxi');
 * @example $tags = $scraper->getAllTagsForUser('toxi',5); // only return the top 5
 *
 */

class DeliciousScraper {
    var $tags;
    
    function __extractUserTags($url) {
        $delHTML = @file($url);
        $tags = array();
        if ($delHTML!=null) {
            $tagOpen = false;
            foreach($delHTML as $n => $line) {
                $type=$this->__getType($line);
                if ($type=='tag') {
                    if ($tagOpen) {
                        $tags[$tagName]=$tagCount;
                    }
                    $tagOpen=true;
                } else
                if ($tagOpen) {
                    if ($type=='count') {
                        preg_match('/">(.*)<\/span>/', $line, $matches);
                        $tagCount=$matches[1];
                        $line = $delHTML[$n+1];
                        preg_match('/<a href="(.*)">/', $line, $matches);
                        $tagName=substr(strrchr($matches[1], "/"), 1);
                    }
                }
                if ($type=='done') return $tags;
            }
        }
        return $tags;
    }
    
    function __getType(&$line) {
        $line = strtolower($line);
        if (strpos($line,'class="delrighttitle"')!=false) return 'starttags';
        if (strpos($line,'class=deltag')!=false || strpos($line,'href="/tag/')!=false) return 'tag';
        if (strpos($line,'class="delnum"')!=false) return 'count';
        if (strpos($line,'class="delpage"')!=false) return 'done';
    }
    
    function getTagsForUser($userID, $maxNum = 25) {
        $this->tags=$this->__extractUserTags('http://del.icio.us/'.$userID);
        // reverse sort all tags by count
        arsort($this->tags);
        $i=0;
        $used=array();
        foreach($this->tags as $tag => $c) {
            array_push($used,$tag);
            if (++$i==$maxNum) break;
        }
        return $used;
    }
    
    function getGlobalTags($url) {
        $delHTML = @file($url);
        $tags = array();
        if ($delHTML!=null) {
            $tagOpen = false;
            foreach($delHTML as $n => $line) {
                $type=$this->__getType($line);
                if (!$tagOpen) {
                    if ($type=='starttags') {
                        $tagOpen=true;
                    }
                } elseif ($type=='tag') {
                    preg_match('/href="(.*)">/', $line, $matches);
                    array_push($tags,substr(strrchr($matches[1], "/"), 1));
                    
                } elseif ($type=='done') return $tags;
            }
        }
        return $tags;
    }
}

?>

