<?php

if (!isset($_POST['submit'])) header("Location: ./index.php");

include('header.inc');
include('relations.php');

function generateOptions($worksWith) {
	global $relOptions;
	$list="";
	$i=1;
	foreach ($relOptions as $o) {
		$list.="<option value=\"$i\"";
		if ($worksWith && $o == "rel:worksWith")
			$list.=' selected="selected"';
		$list.=">$o</option>";
		$i++;
	}
	return $list;
}

function generateForm() {
    // parse file contents
	if (strlen($_POST['importurl']) > 0) {
		$file = @fopen($_POST['importurl'], 'r');
        $filetype='URL';
        $filename=$_POST['importurl'];
	} else
    if (strlen($_FILES['import']['tmp_name'])>0) {
        $file = @fopen($_FILES['import']['tmp_name'], 'r');
        $filetype='file';
        $filename=$_FILES['import']['name'];
    }
    if ($file!=null) {
        // create appropriate parser for import format
        if (strpos($filename,'.vcf')>0) {
            include('vcard2foaf.php');
            $foafgen = new Vcard2FoafGen();
        } else {
            include('ldif2foaf.php');
            $foafgen = new Ldif2FoafGen();
        }
        $foafgen->parseFile($file);
        
        include('entryform.inc');
        
        // pre-compute html <select> statements
        $defaultRelations=generateOptions(false);
        $workRelations=generateOptions(true);
        
        $iter = $foafgen->getEntryIterator();
        $workURL=$_POST['me_workplaceHomepage'];
        $i=1;
        while($iter->hasNext()) {
            $item=$iter->next();
            $entryDomain = substr(strstr($item['mbox'], '@'), 1);
            $isCoworker = (strpos($workURL, $entryDomain) > 0);
            // colour code rows which are coworkers
            echo "<tr id=\"f$i\" ";
            // colour code rows which are coworkers
            if ($isCoworker) echo 'class="coworker" ';
            echo "onmouseover=\"on(this);\"><td>$i</td>";
            echo '<td><input type="checkbox" name="a'.$i.'" /></td>';
            echo "<td><select name=\"b$i\">";
            if ($isCoworker) echo $workRelations;
            else echo $defaultRelations;
            echo '</select></td>';
            echo '<td><input type="text" name="c'.$i.'" value="'.$item['name'].'" onchange="se('.$i.');" /></td>';
            echo '<td><input type="text" name="d'.$i.'"  value="'.$item['nick'].'" onchange="se('.$i.');" /></td>';
            if (gettype($item['mbox'])=='array') {
                echo "<td><select name=\"e$i\" onchange=\"se($i);\">";
                foreach($item['mbox'] as $mb) {
                    echo "<option value=\"$mb\">$mb</option>";
                }
                echo "</select></td>";
            } else {
                echo '<td><input type="text" name="e'.$i.'"  value="'.$item['mbox'].'" onchange="se('.$i.');" /></td>';
            }
            if (!isset($item['homepage'])) {
                echo "<td id=\"fd$i\" onclick=\"ins(this);\"><span class=\"bt2\">details...</span></td>";
            } else {
                echo "<td></td>";
            }
            echo "</tr>\n";
            if (isset($item['homepage'])) {
                echo '<tr class="details" id="fdr'.$i.'_0"><td colspan="2"></td><td>homepage URL</td><td colspan="4"><input type="text" name="f'.$i.'" value="'.$item['homepage'].'" onchange="se('.$i.');" /></td></tr>'."\n";
                echo '<tr class="details" id="fdr'.$i.'_1"><td colspan="2"></td><td>del.icio.us user name</td><td colspan="4"><input type="text" name="h'.$i.'" value="" onchange="se('.$i.');" /></td></tr>'."\n";
                echo '<tr class="details" id="fdr'.$i.'_2"><td colspan="2"></td><td>FOAF profile URL</td><td colspan="4"><input type="text" name="g'.$i.'" value="" onchange="se('.$i.');" /></td></tr>'."\n";
            }
            $i++;
        }
        echo '</table>';
        echo '<input type="hidden" name="numEntries" value="'.$i.'" />';
        echo '<p><a href="javascript:markAll(true);" class="bt">select all</a> <a href="javascript:markAll(false);" class="bt">select none</a></p></div>';
    } else {
        echo '<div><h3>Conversion step skipped</h3>';
        if (isset($filetype)) echo 'Couldn\'t open the given address book '.$filetype." ($filename)";
        else echo 'No address collection specified...';
        echo '<input type="hidden" name="numEntries" value="0" /></div>';
    }
}

function copyFormData() {
    // copy form details from previous page
	foreach ($_POST as $key => $detail) {
		if ($key != 'submit' && $key != 'action')
			echo "<input type=\"hidden\" name=\"$key\" value=\"$detail\" />\n";
	}
}
?>

<form name="entries" method="post" action="generatefoaf.php" onsubmit="return checkEntries();">

<?php
generateForm();
?>

<div class="subsect"><h3>Add more friends...</h3>
If you want to add any more persons which aren't in the above list to your FOAF profile, you can do so here by pressing the "add..." button.
<table id="friendstable">
<tr><th>Relationship</th><th>Name</th><th>Nickname</th><th>E-mail</th></tr>
</table>
</div>
<div><input type="button" value="add..." onclick="addFriend();" /></div>
<div class="formsub">
<h3>FOAF profile options</h3>
<ul>
<li><input type="checkbox" name="usesha1" checked="checked" /> encrypt all e-mail addresses (to avoid spam)</li>
<li><input type="checkbox" name="usedelicious" checked="checked" /> import del.icio.us tags as interests</li>
<li><input type="checkbox" name="autodiscover" disabled="disabled" /> perform FOAF autodiscovery on selected entries [ <a href="#" class="info">info <span>query a database for existing online references to FOAF descriptions of these persons</span></a>] (temporarily unavailable)</li>
<li><input type="checkbox" name="rdffile" /> output as RDF/XML file</li>
</ul>
</div>

<div>Please press "Submit" only once. Depending on the number of selected contacts the generation process can take a upto a minute, especially if automatic lookups are used too.</div>

<?php
copyFormData();
?>

<div class="center">
<input type="submit" name="submit" value="submit" /><input type="reset" value="cancel" />
</div>
</form>

<?php
echo '<div class="small">last updated: ' . date("F d Y H:i:s.", filemtime($_SERVER["SCRIPT_FILENAME"])) . '</div>';
include('footer.inc');
?>
