<?php

class SeeAlsoQuery {
    
    var $baseURL='http://swordfish.rdfweb.org/discovery/2001/08/codepict/rdfxmlquery.jsp?query=select+%3Fseealso+where+%28foaf%3Ambox_sha1sum+%3Fperson+%22{mbox}%22%29+%28rdfs%3AseeAlso+%3Fperson+%3Fseealso%29+using+foaf+for+http%3A%2F%2Fxmlns.com%2Ffoaf%2F0.1%2F+rdfs+for+http%3A%2F%2Fwww.w3.org%2F2000%2F01%2Frdf-schema%23';
    var $URIrefs;
    var $errorMsg;
    
    function SeeAlsoQuery($mbox) {
        $this->baseURL=str_replace('{mbox}',$mbox,$this->baseURL);
        $this->URIrefs=array();
    }
    
    function execute() {
        $xml_parser = xml_parser_create();
        xml_set_object($xml_parser, $this);
        // use case-folding so we are sure to find the tag in $map_array
        xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
        xml_set_element_handler($xml_parser, "startElement", "endElement");
        if (!($fp = @fopen($this->baseURL, "r"))) {
           $this->errorMsg="could not open XML input: ".$this->baseURL;
           xml_parser_free($xml_parser);
           return;
        }
        
        while ($data = fread($fp, 4096)) {
           if (!xml_parse($xml_parser, $data, feof($fp))) {
               $this->errorMsg="XML error: ".xml_error_string(xml_get_error_code($xml_parser))." at line ".xml_get_current_line_number($xml_parser);
               xml_parser_free($xml_parser);
               return;
           }
        }
        xml_parser_free($xml_parser);
        return $this->URIrefs;
    }
    
    function startElement($parser, $name, $attr) {
        if (strpos($name,'SEEALSO')>0) {
            array_push($this->URIrefs,$attr['RDF:RESOURCE']);
        }
    }
    
    function endElement($parser, $tag) { }

    function getError() {
        return $this->errorMsg;
    }
}

?> 
