<table>
<tr>
<td>
<h3>About this tool</h3>
<div>The <a href="http://rdfweb.org/foaf/" class="ext">"Friend Of A Friend"</a> (FOAF) project is part of the <a href="http://www.w3.org/2001/sw/">Semantic Web</a> initiative to describe human relationships in a machine readable form. Each person's profile contains a number of personal information together with brief descriptions of their friends and aquaintances. The relationships themselves can be classified by using different vocabularies and can also include people you have lost contact with or would like to meet one day. If known, a friend's description should also include a link to his or her FOAF description online. That way a FOAF based spider (so called <a href="http://rdfweb.org/topic/Scutter" class="ext">scutters</a>) can explore and connect all existing FOAF descriptions and build a model of a social network.</div>
<div>A more detailed introduction to the HOW's and WHY's of FOAF, please see <a href="http://beta.foaf-project.org/2004/us/about.html" class="ext">here</a>.</div>

<div>Similar to the original <a href="http://www.ldodds.com/foaf/foaf-a-matic" class="ext">FOAF-a-matic</a> by <a href="http://www.ldodds.com/" class="ext">Leigh Dodds</a>, you can use this tool to comfortably <strong>batch convert an email address book, edit and manually add entries to compile them into a FOAF profile</strong> in 3 simple steps. Contacts can be imported as vCards and the LDIF file format. Most email clients can at least output one of these two.</div>
<div>Until now vCards are probably the more commonly available standard for exchanging contact information (<a href="http://www.faqs.org/rfcs/rfc2426.html" class="ext">RFC 2426</a>). LDIF stands for "LDAP Data Interchange Format" and is a slightly newer official Internet standards track protocol (<a href="http://www.faqs.org/rfcs/rfc2849.html" class="ext">RFC 2849</a>). Some e-mail clients (e.g. <a href="http://www.mozilla.org/products/thunderbird/" class="ext">Mozilla Thunderbird</a>) directly support the export of address books in this format.</div>
<div>As address books tend to be quite large, the tool will only consider the first 500 entries. It also tries to pre-process the incoming data to help you with the creation of your profile. People which have your workplace's homepage domain name in their email address are pre-selected with the "worksWith" type of relationship. That value can be of course changed individually.
</div>
</td>
<td>
<h3>Usage</h3>
<div>Fill in all desired fields in form below and upload or choose an online address collection. You can also skip importing any contacts just add them manually. On the next screen you'll see all entries of the selected file. For each person you can specify the type of relationship you have and edit their personal details. Entries you have edited are automatically selected to be included in your FOAF profile, though all other entries need to be included manually. There are also options to select/deselect all.</div>
<div>The final screen will show you the generated FOAF description which should be copied &amp; pasted into a new textfile and saved as "foaf.rdf" somewhere accessible online. There's also an option to save the output as file. More information how to successfully publish and link to your profile can be found on that page.</div>

<h3>Privacy information</h3>
<div>As a rule of thumb, please <strong>only include details in your profile you feel comfortable with to be public</strong>. None of the personal information entered here will be used for any other purposes than to create your FOAF description file and will only be stored on this server until the uploaded address file has been translated. Or, if using the automatic file creation option the generated FOAF file will be deleted after max. 24 hours. <strong>All e-mail addresses (incl. your own) will be encrypted</strong> and stored as a <a href="http://www.w3.org/PICS/DSig/SHA1_1_0.html" class="ext">SHA1</a> digital signature by default, but can be left in its original form if you wish so (see the options on next page). Because FOAF is using e-mail addresses as unique ID for each person, providing your email address and name is mandatory. All other fields are considered optional.
</div>
</td>
</tr>
</table>

<form enctype="multipart/form-data" method="post" action="processentries.php">
<table>
<tr>
<td class="fcol">
<h3>Personal Data</h3>
<fieldset><legend class="small">Some information about you, and how people can contact you</legend>
<table>
<tr><td class="label">Title (Mr, Mrs, Dr, etc)</td>
<td><input type="text" name="me_title" /></td>
</tr>
<tr><td class="label">First Name <span class="mand">*</span></td>
<td><input type="text" name="me_givenName" /></td>
</tr>
<tr><td class="label">Last Name (Family) <span class="mand">*</span></td>
<td><input type="text" name="me_family_name" /></td>
</tr>
<tr><td class="label">Nickname</td>
<td><input type="text" name="me_nick" /></td>
</tr>
<tr><td class="label">Your Email Address <span class="mand">*</span></td>
<td><input type="text" name="me_mbox" /></td>
</tr>
<tr><td class="label">Homepage</td>
<td><input type="text" name="me_homepage" /></td>
</tr>
<tr><td class="label">Weblog</td>
<td><input type="text" name="me_weblog" /></td>
</tr>
<tr><td class="label">Your Picture</td>
<td><input type="text" name="me_depiction" /></td>
</tr>
<tr><td class="label">Primary Instant Messenger ID</td>
<td><input type="text" name="me_imid" />
<select name="imtype">
<option value="">Choose type</option>
<option value="aimChatID">AIM</option>
<option value="icqChatID">ICQ</option>
<option value="jabberID">Jabber</option>
<option value="msnChatID">MSN</option>
<option value="yahooChatID">Yahoo!</option>
</select>
</td>
</tr>
<tr><td class="label">Phone Number</td>
<td><input type="text" name="me_phone" /></td>
</tr>
</table>
</fieldset>
<h3>Contacts</h3>
<fieldset><legend class="small">Upload a file with your email contacts</legend>
<table>
<tr><td class="label">local vCard or LDIF addressbook</td>
<td><input type="file" name="import" value="" /></td>
</tr>
<tr><td class="label"><strong>or</strong></td></tr>
<tr><td class="label">addressbook URL</td>
<td><input type="text" name="importurl" value="" /></td>
</tr>
<tr><td class="label">you can use these test files <a href="test.ldif">LDIF</a>, <a href="test.vcf">vCards</a></td></tr>
</table></fieldset>
</td>
<td>
<h3>Work</h3>
<fieldset><legend class="small">Information about your work place</legend>
<table>
<tr><td class="label">Work Homepage</td>
<td><input type="text" name="me_workplaceHomepage" /></td></tr>
<tr><td class="label">Page describing what you do at work</td>
<td><input type="text" name="me_workInfoHomepage" /></td></tr>
</table>
</fieldset>
<h3>School</h3>        
<fieldset><legend class="small">Where did you go to school/university/college?</legend>
<table>
<tr><td class="label">School Homepage</td>
<td><input type="text" name="me_schoolHomepage" /></td></tr>
</table></fieldset>
<h3>Interests</h3>        
<fieldset><legend class="small">List your favourite interests</legend>
<table>
<tr><td colspan="2">If possible interests should relate to online resources about a particular subject, ie. specify them as URL. If you are a user of <a href="http://del.icio.us">del.icio.us</a> simply type in your user name and the tool will use the 10 most used tags as your interests.</td></tr>
<tr><td class="label">del.icio.us user name</td>
<td><input type="text" name="me_delicious" /></td></tr>
<tr><td colspan="2">or</td></tr>
<tr><td class="label">Interest #1</td>
<td><input type="text" name="me_interest1" /></td></tr>
<tr><td class="label">Interest #2</td>
<td><input type="text" name="me_interest2" /></td></tr>
<tr><td class="label">Interest #3</td>
<td><input type="text" name="me_interest3" /></td></tr>
<tr><td class="label">Interest #4</td>
<td><input type="text" name="me_interest4" /></td></tr>
<tr><td class="label">Interest #5</td>
<td><input type="text" name="me_interest5" /></td></tr>
</table></fieldset>
</td>
</tr>
<tr>
<td>
<input type="submit" name="submit" value="continue" />&nbsp;
<input type="reset" name="reset" value="reset" />
<input type="hidden" name="action" value="upload" />
</td>
<td>
<span class="mand">*</span> mandatory fields
</td>
</tr>
</table>
</form>

<div class="subsect">
<h3>Source code &amp; Credits</h3>
The source code for this project is released under the Creative Commons License and can be downloaded from here:<br/>
<a href="foafgen_v0.3.0.zip">foafgen_v0.3.0.zip</a></div>

<div><span class="hd">Requirements:</span>
<ul>
<li>PHP 4.x.x or later</li>
<li><a href="http://www.wiwiss.fu-berlin.de/suhl/bizer/rdfapi/index.html">RdfAPI-PHP</a> (RAP) v0.9.1 or later</li>
</ul>
Author: Karsten Schmidt &lt;<a href="javascript:mailtoscramble('info','toxi.co.uk','?subject=foafgen');">info at toxi dot co dot uk</a>&gt;<br />
my FOAF profile URL: <a href="http://toxi.co.uk/foaf.rdf">http://toxi.co.uk/foaf.rdf</a><br />
Thanks to Leigh Dodds, Libby Miller and everyone on #foaf
</div>

<div class="subsect" id="history"><h3>Version history:</h3>
<span class="hd">v0.3.0</span>
<ul>
    <li>added vCard import support (plaintext format)</li>
    <li>now accepts multiple entries for each field value (eg. nickname or email addresses), shown as list box</li>
    <li>new features related to del.icio.us:</li>
    <ul>
        <li>added rdfs:seeAlso to RSS feed for interest links</li>
        <li>added onlineAccount description</li>
        <li>added rdfs:seeAlso to <a href="http://philwilson.org:8180/foaflicious/">foafalicious</a></li>
    </ul>
</ul>
<span class="hd">v0.2.3</span>
<ul>
    <li>del.icio.us tag retrieval now also works for selected friends</li>
</ul>
<span class="hd">v0.2.2</span>
<ul>
    <li>autodiscovery of foaf:interest's from del.icio.us user page</li>
</ul>
<span class="hd">v0.2.1</span>
<ul>
    <li>added creation date and generatorAgent info</li>
</ul>

<span class="hd">v0.2</span>
<ul>
    <li>complete rewrite of PHP code</li>
    <li>optional output of FOAF as file</li>
    <li>uses JS DOM to add extra information for each contact</li>
    <li>attempt autodiscovery of existing foaf profiles of selected friends using swordfish.rdfweb.org DB</li>
    <li>additional manual input of contacts not included in LDIF file</li>
</ul>

<span class="hd">v0.1.2</span>
<ul>
    <li>added "foaf:interest" fields in personal info</li>
    <li>added IM chat ID field</li>
    <li>added "foaf:PersonalProfileDocument" node</li>
    <li>friends now described using "foaf:Person" types</li>
    <li>support for "rdfs:seeAlso" fields for friend's profiles</li>
</ul>
  
<span class="hd">v0.1.1</span>
<ul>
<li>initial public version</li>
<li>support for LDIF URL's, not just local files</li>
<li>"rel:worksWith" is pre-selected as relationship for entries with the same domain name in e-mail address as work homepage</li>
<li>"foaf:nick" is only used if different to "foaf:name" value</li>
<li>autostrip quotes from names</li>
</ul>
</div>
<div class="subsect"><h3>To do's:</h3>
<ul>
<li>improved autodiscovery features using 3rd party webservices</li>
<li>support more databases for seeAlso queries</li>
<li>find workaround for IE DOM bugs (adding further contacts doesn't work in IE)</li>
<li>provide more information how to publish FOAF</li>
<li>ability to edit existing FOAF files</li>
<li>more foaf/relationship vocabularies</li>
<li>form validation</li>
</ul>
</div>
